import Provider from "../higher-order/Provider";
import { Config, WatcherListeners } from "interfaces";
/**
 * Nodehawk is a hyper configurable watcher for all of your Node server development needs.
 * @extends Provider
 * @category Core
 * @example
 * ```
 * import Nodehawk from 'nodehawk';
 * const nodehawk = new Nodehawk();
 * ```
 */
export default class Main extends Provider {
    /**
     * Instance of `Watcher` created for this instance.
     */
    private watcher;
    /**
     * Create an instance of `Nodehawk` which reads the configuration file and spawns a watcher to execute commands.
     * @param {Config} [userConfig] Part of a custom config, to override defaults. Useful while running Nodehawk programmatically.
     * @param {WatcherListeners} [watcherListeners] A list of custom listeners to run against certain events.
     */
    constructor(userConfig?: Config, watcherListeners?: WatcherListeners);
}
